Subject: Re: bug#35625: Python3 Cannot Find Existing Shared Library within guix environment

From: Jesse Gibbons <[email-masked]>
Date: Sun, 19 May 2019 18:46:16 -0600

The good news is this bug is no longer an impediment to installing the
package because I took a(n arguably foolish) risk and disabled the tests
in the package definition (see attachment: rednotebook.scm). The bad
news is this bug persists when I run the installed package. When I
install rednotebook and run it, I get an error like the following:

Adding /gnu/store/cb2qs9gg7jlb83qc9k1aballzrfvia35-rednotebook-2.11.1/lib/python3.7/site-packages
to sys.path 2019-05-19 18:00:57,995 INFO     Writing log to file
"/home/jesse/.rednotebook/rednotebook.log" 2019-05-19 18:00:57,995
INFO     System encoding: utf-8 2019-05-19 18:00:57,995 INFO
Language code: en_US 2019-05-19 18:00:58,054 WARNING  For spell
checking, please install enchant (python3-enchant).

** (.rednotebook-real:5662): WARNING **: 18:00:58.089: Failed to load
shared library 'libwebkit2gtk-4.0.so.37' referenced by the typelib:
libwebkit2gtk-4.0.so.37: cannot open shared object file: No such file
or directory

** (.rednotebook-real:5662): WARNING **: 18:00:58.089: Failed to load
shared library 'libjavascriptcoregtk-4.0.so.18' referenced by the
typelib: libjavascriptcoregtk-4.0.so.18: cannot open shared object
file: No such file or
directory /gnu/store/f34bv1iaghh7hsymqm57abi8p1lyavv6-python-pygobject-3.28.3/lib/python3.7/site-packages/gi/types.py:226:
Warning: cannot derive 'rednotebook+gui+browser+Browser' from
non-derivable parent type 'void' _gi.type_register(cls,
namespace.get('__gtype_name__')) Traceback (most recent call last):
File
"/gnu/store/cb2qs9gg7jlb83qc9k1aballzrfvia35-rednotebook-2.11.1/bin/.rednotebook-real",
line 6, in <module> import journal ModuleNotFoundError: No module named
'journal'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File
"/gnu/store/cb2qs9gg7jlb83qc9k1aballzrfvia35-rednotebook-2.11.1/bin/.rednotebook-real",
line 11, in <module> import rednotebook.journal File
"/gnu/store/cb2qs9gg7jlb83qc9k1aballzrfvia35-rednotebook-2.11.1/lib/python3.7/site-packages/rednotebook/journal.py",
line 168, in <module> from rednotebook.gui.main_window import
MainWindow File
"/gnu/store/cb2qs9gg7jlb83qc9k1aballzrfvia35-rednotebook-2.11.1/lib/python3.7/site-packages/rednotebook/gui/main_window.py",
line 45, in <module> from rednotebook.gui import browser File
"/gnu/store/cb2qs9gg7jlb83qc9k1aballzrfvia35-rednotebook-2.11.1/lib/python3.7/site-packages/rednotebook/gui/browser.py",
line 41, in <module> class Browser(WebKit2.WebView): File
"/gnu/store/f34bv1iaghh7hsymqm57abi8p1lyavv6-python-pygobject-3.28.3/lib/python3.7/site-packages/gi/types.py",
line 235, in __init__ super(GObjectMeta, cls).__init__(name, bases,
dict_) File
"/gnu/store/f34bv1iaghh7hsymqm57abi8p1lyavv6-python-pygobject-3.28.3/lib/python3.7/site-packages/gi/types.py",
line 214, in __init__ cls._type_register(cls.__dict__) File
"/gnu/store/f34bv1iaghh7hsymqm57abi8p1lyavv6-python-pygobject-3.28.3/lib/python3.7/site-packages/gi/types.py",
line 226, in _type_register _gi.type_register(cls,
namespace.get('__gtype_name__')) RuntimeError: could not create new
GType: rednotebook+gui+browser+Browser (subclass of void)

Looks like this bug infests more than a temporary guix
environment. The program crashes unable to find some essential class
definitions even when I add a directory containing the necessary shared
libraries to $LD_LIBRARY_PATH and check that GI_TYPELIB_PATH has the
necessary typelib files.